#pragma once

#ifndef __SCANNER_H__
#define __SCANNER_H__

#include <stdint.h>
#include <variant>

namespace gen
{
	typedef uint16_t index_t;
	class Scanner;
	class Parser;

	typedef std::variant<int, int64_t, double, const char*> generic_t;
}

class Driver
{
protected:
	gen::Parser* pParser;
	gen::Scanner* pScanner;

public:
	Driver();
	virtual ~Driver();
	gen::Parser* getParser() const { return pParser; }
	gen::Scanner* getScanner() const { return pScanner; }
};

#endif // __SCANNER_H__
