#pragma once

#ifndef SCANNER_H__
#define SCANNER_H__

  // Scanner method signature is defined by this macro. Original yylex() returns int.
  // Since Bison 3 uses symbol_type, we must change returned type. We also rename it
  // to something sane, since you cannot overload return type.
#undef YY_DECL
#define YY_DECL gen::Parser::symbol_type gen::Scanner::get_next_token()

#if !defined(yyFlexLexerOnce)
#undef yyFlexLexer
#define yyFlexLexer genFlexLexer
#include <FlexLexer.h>
#endif

#include "parser.h" // this is needed for symbol_type
#include "location.hh"

namespace gen {
    typedef uint16_t index_t;

    class Scanner : public yyFlexLexer {
        friend class Parser;
        friend class Driver;
    public:
        Driver* pDriver;
        location loc;

        Scanner(Driver * pd) :pDriver(pd) {}
        virtual ~Scanner();
        virtual Parser::symbol_type get_next_token();
    };

} // namespace gen

#endif // __SCANNER_H__
